<template>
  <component
    :is="elemType"
    :style="computedStyle"
    :class="[$style.defaultTypo, $style[type]]"
  >
    <slot></slot>
  </component>
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import ThemeDefaults from "@/components/theme/defaults";
export enum TypoColorTypes {
  PRIMARY = "primary",
  GRAY = "GRAY",
  DANGER = "DANGER"
}
export default Vue.extend({
  name: "BaseTypography",
  props: {
    type: {
      type: String,
      required: false
    },
    elemType: {
      type: String,
      required: false,
      default: "p"
    },
    fontSize: {
      type: String,
      required: false
    },
    color: {
      type: String as PropType<TypoColorTypes>,
      required: false,
      validator: (value: string) => {
        return value ? true : false;
      }
    }
  },
  computed: {
    computedStyle: function() {
      const { fontSize } = this;
      return {
        color: ThemeDefaults.pallete[String(this.color)] || this.color,
        fontSize
      };
    }
  }
});
</script>

<style module lang="scss">
.defaultTypo {
  composes: typography--default;
}
.light {
  font-weight: 300;
}
.regular {
  font-weight: 400;
}
.bold {
  font-weight: 700;
}
.extra-bold {
  font-weight: 700;
}
</style>
